function varargout = eddy_manual_selection(varargin)
% EDDY_MANUAL_SELECTION MATLAB code for eddy_manual_selection.fig
%      EDDY_MANUAL_SELECTION, by itself, creates a new EDDY_MANUAL_SELECTION or raises the existing
%      singleton*.
%
%      H = EDDY_MANUAL_SELECTION returns the handle to a new EDDY_MANUAL_SELECTION or the handle to
%      the existing singleton*.
%
%      EDDY_MANUAL_SELECTION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EDDY_MANUAL_SELECTION.M with the given input arguments.
%
%      EDDY_MANUAL_SELECTION('Property','Value',...) creates a new EDDY_MANUAL_SELECTION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before eddy_manual_selection_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to eddy_manual_selection_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help eddy_manual_selection

% Last Modified by GUIDE v2.5 19-Dec-2013 14:24:52
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @eddy_manual_selection_OpeningFcn, ...
                   'gui_OutputFcn',  @eddy_manual_selection_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before eddy_manual_selection is made visible.
function eddy_manual_selection_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to eddy_manual_selection (see VARARGIN)

global selection
global rotate_max_area;
global max_angle_diff;

rotate_max_area = 4;
max_angle_diff = 72;

selection = 0;

set(handles.popupmenu4,'Visible','off');
set(handles.popupmenu5,'Visible','off');
set(handles.togglebutton1,'Visible','off');
set(handles.togglebutton2,'Visible','off');
set(handles.togglebutton3,'Visible','off');
set(handles.uipanel1,'Visible','off');
set(handles.pushbutton2,'Visible','off');
set(handles.text3,'Visible','off');
set(handles.text4,'Visible','off');

reshape_window(handles);

% Choose default command line output for eddy_manual_selection
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes eddy_manual_selection wait for user response (see UIRESUME)
% uiwait(handles.figure1);


function reshape_window(handles)

optimal_resolution = [1280 1024];
screen = get(0,'screensize');

coef_width = optimal_resolution(1)/screen(3);
coef_height = optimal_resolution(2)/screen(4);

pos = get(handles.figure1,'position');
set(handles.figure1,'position',[pos(1) pos(2) coef_width*pos(3) coef_height*pos(4)]);



% --- Outputs from this function are returned to the command line.
function varargout = eddy_manual_selection_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global eddy_index;
global info_eddy;
global info_eddy_array;
global graphic_eddy;
global graphic_eddy_array;
global depth;

if(info_eddy_array(eddy_index).r2(depth) > 0)
    if(divisions_are_viewed)
        set(handles.checkbox2,'Value',0);
        delete_graphic_divisions;
        delete_graphic_fill(handles);
        plot_center(eddy_index);
        plot_rads(eddy_index);
    end
    eddy_index = get(handles.popupmenu6,'String');
    if(length(eddy_index)>1)
        eddy_index = str2num(cell2mat(eddy_index(length(eddy_index))))+1;
    else
        eddy_index = 2;
    end
    info_eddy_array = [info_eddy_array,info_eddy];
    graphic_eddy_array = [graphic_eddy_array,graphic_eddy];
    eddies_to_select = cell(eddy_index,1);
    for i=1:length(eddies_to_select)
        eddies_to_select(i) = num2cell(i);
    end
    set(handles.popupmenu2,'Value',1);
    set(handles.popupmenu3,'Value',1);
    set(handles.popupmenu6,'String',eddies_to_select);
    set(handles.popupmenu6,'Value',eddy_index);
    set(handles.text11,'String',' ');
    set(handles.pushbutton2,'Visible','off');
    set(handles.pushbutton5,'Visible','off');
    set(handles.togglebutton2,'Visible','off');
else
    disp('Current eddy must be selected before create new eddy');
end


% --- Executes when selected object is changed in uipanel4.
function uipanel4_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel4 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
global selection;
global info_eddy_array;
global eddy_index;

global depth;

global axes_eddy_1;
global axes_eddy_2;

global longitudes;

switch get(eventdata.NewValue,'String')
    case 'Select Center'
        delete_graphic_fill(handles);
        selection = 0;
        if(axes_eddy_1 ~= 0)
            delete(axes_eddy_1);
            delete(axes_eddy_2);
            axes_eddy_1 = 0;
            axes_eddy_2 = 0;
        end
    case 'Select Radio 1'
        delete_graphic_fill(handles);
        selection = 1;
        if(info_eddy_array(eddy_index).c_lon(depth) ~= 0)
            if(axes_eddy_1 ~= 0)
                delete(axes_eddy_1);
                delete(axes_eddy_2);
            end
            axes_eddy_1 = plot([info_eddy_array(eddy_index).c_lon(depth) info_eddy_array(eddy_index).c_lon(depth)],[info_eddy_array(eddy_index).c_lat(depth) info_eddy_array(eddy_index).c_lat(depth)+5*(longitudes(2)-longitudes(1))],'r','linewidth',3);
            axes_eddy_2 = plot([info_eddy_array(eddy_index).c_lon(depth) info_eddy_array(eddy_index).c_lon(depth)+5*(longitudes(2)-longitudes(1))],[info_eddy_array(eddy_index).c_lat(depth) info_eddy_array(eddy_index).c_lat(depth)],'r','linewidth',3);
        end
    case 'Select Radio 2'
        delete_graphic_fill(handles);
        selection = 2;
        if(info_eddy_array(eddy_index).r1(depth) ~= 0)
            if(axes_eddy_1 ~= 0)
                delete(axes_eddy_1);
                delete(axes_eddy_2);
            end
            axes_eddy_1 = plot([info_eddy_array(eddy_index).c_lon(depth) info_eddy_array(eddy_index).c_lon(depth)],[info_eddy_array(eddy_index).c_lat(depth) info_eddy_array(eddy_index).c_lat(depth)+5*(longitudes(2)-longitudes(1))],'linewidth',3);
            axes_eddy_2 = plot([info_eddy_array(eddy_index).c_lon(depth) info_eddy_array(eddy_index).c_lon(depth)-5*(longitudes(2)-longitudes(1))],[info_eddy_array(eddy_index).c_lat(depth) info_eddy_array(eddy_index).c_lat(depth)],'linewidth',3);
        end
    case 'Set Speed'
        selection = 3;
        if(axes_eddy_1 ~= 0)
            delete(axes_eddy_1);
            delete(axes_eddy_2);
            axes_eddy_1 = 0;
            axes_eddy_2 = 0;
        end
end


% --- Executes during object creation, after setting all properties.
function uipanel4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on mouse press over figure background, over a disabled or
% --- inactive control, or over an axes background.
function figure1_WindowButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global graphic_eddy_array;
global info_eddy_array;
global eddy_index; 
global depth;
global longitudes;
global latitudes;

currentPoint = get(handles.axes2,'CurrentPoint');
if((currentPoint(1,1) >= longitudes(1)) && (currentPoint(1,2) >= latitudes(1)) && (currentPoint(1,1) < longitudes(length(longitudes))) && (currentPoint(1,2) < latitudes(length(latitudes))))
    if(graphic_eddy_array(eddy_index).ellipse ~= 0)
        delete(graphic_eddy_array(eddy_index).ellipse);
    end
    change_eddy_parameters(currentPoint,handles);
    if((get(handles.checkbox1,'value') == 1) && (info_eddy_array(eddy_index).r2(depth) ~= 0))
        [X Y] = calculate_ellipse(info_eddy_array(eddy_index).c_lon(depth), info_eddy_array(eddy_index).c_lat(depth), info_eddy_array(eddy_index).r1(depth), info_eddy_array(eddy_index).r2(depth), -info_eddy_array(eddy_index).angle(depth)*180/pi);
        graphic_eddy_array(eddy_index).ellipse = plot(X,Y,'linewidth',2);
    end
else
    disp('fuera del mapa');
end


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1
if(get(hObject,'Value') == 1)
    plot_ellipses;
else
    delete_graphic_ellipses;
end


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global eddy_map_array;
global info_eddy_array;
global time;
global name;
global longitudes;
global latitudes;
global U;
global V;

for i=1:length(eddy_map_array)
    if(eddy_map_array(i).t == time)
        eddy_map_array(i).eddies = info_eddy_array;
        break;
    end
end
useful = 0;
useful_2 = 0;
maps_to_delete = [];
for i=1:length(eddy_map_array)
    if(eddy_map_array(i).t == -1)
        maps_to_delete = [maps_to_delete,i];
    else
        deb=length(eddy_map_array(i).eddies);
        deb1 = eddy_map_array(i).t;
        for j=1:length(eddy_map_array(i).eddies)
            for k=1:length(U(1,1,:,1))
                if(eddy_map_array(i).eddies(j).r2(k) ~= 0)
                    useful = 1;
                    useful_2 = 1;
                end
            end
            if(~useful_2)
                eddy_map_array(i).eddies(j) = [];
            end
            useful_2 = 0;
        end
        if(useful == 0)
            maps_to_delete = [maps_to_delete,i];
        end
        useful = 0;
    end
end
for i=1:length(maps_to_delete)
    eddy_map_array(maps_to_delete(i)) = [];
end
if((length(name) > 6) && (strcmp(name(1:6),'manual')))
    file = strcat(name,'.mat');
else
    file = strcat(strcat('manual_eddy_',name),'.mat');
end
manual_eddy_map_info = eddy_map_array;
lons = longitudes;
lats = latitudes;
mUVZH.u = U;
mUVZH.v = V;
save(file,'manual_eddy_map_info','lons','lats','mUVZH')



% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2
global info_eddy_array;
global eddy_index;
global U;

info_eddy_array(eddy_index).rad_div = get(hObject,'Value');
info_eddy_array(eddy_index).speed = zeros(length(U(1,1,:,1)),info_eddy_array(eddy_index).rad_div,info_eddy_array(eddy_index).ang_div);



% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu3.
function popupmenu3_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu3 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu3
global info_eddy_array;
global eddy_index;
global U;

info_eddy_array(eddy_index).ang_div = get(hObject,'Value');
info_eddy_array(eddy_index).speed = zeros(length(U(1,1,:,1)),info_eddy_array(eddy_index).rad_div,info_eddy_array(eddy_index).ang_div);


% --- Executes during object creation, after setting all properties.
function popupmenu3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2
global axes_eddy_1;
global axes_eddy_2;

global info_eddy_array;
global eddy_index;

global depth;

if(info_eddy_array(eddy_index).r2(depth) ~= 0)
    if(get(hObject,'Value')==0)
        delete_graphic_divisions;
        delete_graphic_fill(handles);
        plot_center(eddy_index);
        plot_rads(eddy_index);
    else
        if(axes_eddy_1 ~= 0)
            delete(axes_eddy_1);
            delete(axes_eddy_2);
            axes_eddy_1 = 0;
            axes_eddy_2 = 0;
        end
        delete_graphic_center;
        delete_graphic_rads;
        plot_divisions;
    end
end


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global filled_vertexes;
global radial_index;
global angular_index;
global info_eddy_array;
global eddy_index;
global depth;

delete_graphic_fill(handles);
filled_vertexes = [];

info_eddy_array(eddy_index).speed(depth,radial_index,angular_index) = str2num(get(handles.edit2,'String'));

set(handles.edit2,'Visible','off');
set(handles.pushbutton3,'Visible','off');


% --- Executes on selection change in popupmenu4.
function popupmenu4_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu4 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu4
global time;
global depth;
global eddy_map_array;
global info_eddy_array;
global graphic_eddy_array;
global graphic_eddy;
global eddy_map;
global eddy_index;
global axes_eddy_1;
global axes_eddy_2;
global longitudes;
global latitudes;
global U;
global V;

compare = get(handles.togglebutton2,'Value');

set(handles.togglebutton1,'Value',0);
set(handles.togglebutton2,'Value',0);
set(handles.togglebutton3,'Value',0);
set(handles.checkbox2,'Value',0);
set(handles.uipanel1,'Visible','on');
hold off;
if(axes_eddy_1 ~= 0)
    axes_eddy_1 = 0;
    axes_eddy_2 = 0;
end
if(compare == 0)
    ax = axis;
end
for i=1:length(eddy_map_array)
    if(eddy_map_array(i).t == time)
        eddy_map_array(i).eddies = info_eddy_array;
        break;
    end
end
time = get(hObject,'Value');
res = 0;
for i=1:length(eddy_map_array)
    if(eddy_map_array(i).t == time)
        res = 1;
        time_index = i;
        break;
    end
end
eddy_index = 1;
if(res)
    info_eddy_array = eddy_map_array(time_index).eddies;
    eddies_to_select = cell(length(info_eddy_array),1);
    for i=1:length(eddies_to_select)
        eddies_to_select(i) = num2cell(i);
    end
    set(handles.popupmenu6,'String',eddies_to_select);
    set(handles.popupmenu6,'Value',eddy_index);
    if(info_eddy_array(eddy_index).r2(depth) > 0)
        set(handles.pushbutton2,'Visible','on');
        set(handles.pushbutton5,'Visible','on');
        set(handles.togglebutton2,'Visible','on');
        set(handles.text11,'String',strcat(strcat(strcat(strcat('[ ',num2str(info_eddy_array(eddy_index).c_lon(depth))),', '),num2str(info_eddy_array(eddy_index).c_lat(depth))),' ]'));
    else
        set(handles.pushbutton2,'Visible','off');
        set(handles.pushbutton5,'Visible','off');
        set(handles.togglebutton2,'Visible','off');
    end
else
    eddies_to_select = cell(1,1);
    eddies_to_select(1) = num2cell(1);
    set(handles.text11,'String',' ');
    set(handles.popupmenu6,'String',eddies_to_select);
    set(handles.popupmenu6,'Value',1);
    eddy_map.t = time;
    eddy_map_array = [eddy_map_array,eddy_map];
    info_eddy_array = eddy_map.eddies;
    set(handles.pushbutton2,'Visible','off');
    set(handles.pushbutton5,'Visible','off');
    set(handles.togglebutton2,'Visible','off');
end
set(handles.popupmenu2,'Value',info_eddy_array(eddy_index).rad_div);
set(handles.popupmenu3,'Value',info_eddy_array(eddy_index).ang_div);
set(handles.pushbutton3,'Visible','off');
set(handles.edit2,'Visible','off');
set_graphic_handlers;
draw_map(longitudes,latitudes,U,V,depth,time);
if(compare == 0)
    axis(ax);
end
graphic_eddy_array = [];
for i=1:length(info_eddy_array)
    graphic_eddy_array = [graphic_eddy_array,graphic_eddy];
end
hold on;
plot_eddies(handles);




% --- Executes during object creation, after setting all properties.
function popupmenu4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in popupmenu5.
function popupmenu5_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu5 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu5
global info_eddy_array;
global eddy_index;
global time;
global depth;
global longitudes;
global latitudes;
global U;
global V;

compare = get(handles.togglebutton2,'Value');

set(handles.togglebutton1,'Value',0);
set(handles.togglebutton2,'Value',0);
set(handles.togglebutton3,'Value',0);
set(handles.uipanel1,'Visible','on');

set_graphic_handlers;
set(handles.checkbox2,'Value',0);
set(handles.edit2,'Visible','off');
set(handles.pushbutton3,'Visible','off');

hold off;
if(compare == 0)
    ax = axis;
end
depth = get(hObject,'Value');

if(info_eddy_array(eddy_index).r2(depth) > 0)
    set(handles.pushbutton2,'Visible','on');
    set(handles.pushbutton5,'Visible','on');
    set(handles.togglebutton2,'Visible','on');
    set(handles.text11,'String',strcat(strcat(strcat(strcat('[ ',num2str(info_eddy_array(eddy_index).c_lon(depth))),', '),num2str(info_eddy_array(eddy_index).c_lat(depth))),' ]'));
else
    set(handles.pushbutton2,'Visible','off');
    set(handles.pushbutton5,'Visible','off');
    set(handles.togglebutton2,'Visible','off');
    set(handles.text11,'String','');
end


draw_map(longitudes,latitudes,U,V,depth,time);
if(compare == 0)
    axis(ax);
end
hold on;
plot_eddies(handles);





% --- Executes during object creation, after setting all properties.
function popupmenu5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3


% --- Executes on selection change in popupmenu6.
function popupmenu6_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu6 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu6
global info_eddy_array;
global eddy_index;
global depth;

if(info_eddy_array(eddy_index).r2(depth) > 0)
    if(divisions_are_viewed)
        set(handles.checkbox2,'Value',0);
        delete_graphic_divisions;
        delete_graphic_fill(handles);
        plot_center(eddy_index);
        plot_rads(eddy_index);
    end
    eddy_index = get(hObject,'Value');
    set(handles.popupmenu2,'Value',info_eddy_array(eddy_index).rad_div);
    set(handles.popupmenu3,'Value',info_eddy_array(eddy_index).ang_div);
    if(info_eddy_array(eddy_index).r2(depth) > 0)
        set(handles.text11,'String',strcat(strcat(strcat(strcat('[ ',num2str(info_eddy_array(eddy_index).c_lon(depth))),', '),num2str(info_eddy_array(eddy_index).c_lat(depth))),' ]'));
    end
else
    set(handles.popupmenu6,'Value',eddy_index);
    disp('New eddy must be selected');
end


% --- Executes during object creation, after setting all properties.
function popupmenu6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function uitoggletool5_OnCallback(hObject, eventdata, handles)
% hObject    handle to uitoggletool5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%axis equal;


% --------------------------------------------------------------------
function uipushtool5_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global time;
global depth;

global selection;
global axes_eddy_1;
global axes_eddy_2;

global filled_vertexes;
global fill_handler;
global radial_index;
global angular_index;
    
global eddy_division_ellipses;

global graphic_eddy;
global graphic_eddy_array;

global info_eddy;
global info_eddy_array;
global eddy_index;

global eddy_map;
global eddy_map_array;

global automatic_map_array;

global error;

global name;

global longitudes;
global latitudes;
global U;
global V;

global rotate_max_area;
global max_angle_diff;

rotate_max_area = 4;
max_angle_diff = 72;

file_name = uigetfile('*.mat');
load(file_name);

name = file_name(1:length(file_name)-4);

set(handles.text16,'String',name);

longitudes = lons;
latitudes = lats;
U = mUVZH.u;
V = mUVZH.v;

error = zeros(length(U(1,1,:,1)),length(V(1,1,1,:)));

time = 1;
depth = 1;

axes_eddy_1 = 0;
axes_eddy_2 = 0;

filled_vertexes = [];
fill_handler = 0;

radial_index = 0;
angular_index = 0;

eddy_division_ellipses = [];

graphic_eddy = struct('center',0,'r1',0,'r2',0,'ellipse',0,'ellipse_rad_div',[],'ellipse_ang_div',[]);
graphic_eddy_array = graphic_eddy;

info_eddy = struct('c_lon',zeros(1,length(U(1,1,:,1))),'c_lat',zeros(1,length(U(1,1,:,1))),'r1',zeros(1,length(U(1,1,:,1))),'r2',zeros(1,length(U(1,1,:,1))),'angle',zeros(1,length(U(1,1,:,1))),'modified_depths',zeros(1,length(U(1,1,:,1))),'rad_div',1,'ang_div',1,'speed',zeros(length(U(1,1,:,1)),1,1));
info_eddy_array = info_eddy;
eddy_index = 1;

eddy_map = struct('t',-1,'eddies',info_eddy_array);
eddy_map.t = 1;
eddy_map_array = eddy_map;

automatic_map_array(length(U(1,1,:,1)),length(U(1,1,1,:))).eddies = [];

for i=1:length(U(1,1,:,1))
    for j=1:length(U(1,1,1,:))
        automatic_map_array(i,j).eddies = [];
    end
end

global step_lon;
global step_lat;

step_lon = longitudes(2) - longitudes(1);
step_lat = latitudes(2) - latitudes(1);

times = cell(length(U(1,1,1,:)),1);
times(1) = num2cell(1);

for i=2:length(U(1,1,1,:))
    times(i) = num2cell(i);
end

depths = cell(length(U(1,1,:,1)),1);
depths(1) = num2cell(1);

for i=2:length(U(1,1,:,1))
    depths(i) = num2cell(i);
end

set(handles.edit3,'Visible','on');
set(handles.edit4,'Visible','on');

set(handles.pushbutton3,'Visible','off');
set(handles.edit2,'Visible','off');
set(handles.popupmenu4,'Visible','on');
set(handles.popupmenu5,'Visible','on');
set(handles.popupmenu4,'String',times);
set(handles.popupmenu5,'String',depths);

set(handles.uipanel1,'Visible','on');

set(handles.pushbutton5,'Visible','off');
set(handles.pushbutton2,'Visible','off');
set(handles.togglebutton2,'Visible','off');
set(handles.togglebutton1,'Visible','on');
set(handles.togglebutton3,'Visible','on');
set(handles.text3,'Visible','on');
set(handles.text4,'Visible','on');

set(handles.edit3,'String','4');
set(handles.edit4,'String','72');

set(handles.popupmenu6,'String','1');

set(handles.popupmenu6,'Value',1);
set(handles.popupmenu2,'Value',1);
set(handles.popupmenu3,'Value',1);

hold off;
draw_map(longitudes,latitudes,U,V,depth,time);
hold on;
axis equal;

if(exist('manual_eddy_map_info'))

    eddy_map_array = manual_eddy_map_info;
    info_eddy_array = eddy_map_array(1).eddies;
    eddies = cell(length(eddy_map_array(1).eddies),1);
    eddies(1) = num2cell(1);

    for i=2:length(eddy_map_array(1).eddies)
        eddies(i) = num2cell(i);
    end
    set(handles.popupmenu4,'Value',1);
    set(handles.popupmenu5,'Value',1);
    set(handles.popupmenu6,'String',eddies);
    
    set(handles.popupmenu2,'Value',info_eddy_array(1).rad_div);
    set(handles.popupmenu3,'Value',info_eddy_array(1).ang_div);

    hold on;
    set_graphic_handlers;
    plot_eddies(handles);
    set(handles.pushbutton2,'Visible','on');
    set(handles.pushbutton5,'Visible','on');
    set(handles.togglebutton2,'Visible','on');

    set(handles.togglebutton1,'Value',0);
    set(handles.togglebutton2,'Value',0);
    set(handles.togglebutton3,'Value',0);
end





%AUXILIAR FUNCTIONS SECTION


function set_graphic_handlers

global graphic_eddy_array;
global info_eddy_array;
global filled_vertexes;
global fill_handler;
global eddy_division_ellipses;   
global axes_eddy_1;
global axes_eddy_2;
    
axes_eddy_1 = 0;
axes_eddy_2 = 0;
for i=1:length(info_eddy_array)
    graphic_eddy_array(i).center = 0;
    graphic_eddy_array(i).r1 = 0;
    graphic_eddy_array(i).r2 = 0;
    graphic_eddy_array(i).ellipse = 0;
    graphic_eddy_array(i).ellipse_rad_div = [];
    graphic_eddy_array(i).ellipse_ang_div = [];
end
filled_vertexes = [];
fill_handler = 0;
eddy_division_ellipses = [];

    
function plot_eddies(handles)

global info_eddy_array;
global depth;
    
for i=1:length(info_eddy_array);
    plot_rads(i);
    if(info_eddy_array(i).c_lat(depth) ~= 0)
        plot_center(i);
    end
end
if(get(handles.checkbox1,'Value') == 1)
    plot_ellipses;
end


function [h_rings,h_cheeses]=ellipse(xc,yc,r1,r2,angle,rings,cheese)

global eddy_division_ellipses;
    
div1=r1/rings;
div2=r2/rings;

eddy_division_ellipses = zeros(rings,2,36);

h_rings = zeros(1,rings);
h_cheeses = zeros(1,cheese);
for i=0:rings-1
    [elli(1,:),elli(2,:)]=calculate_ellipse(xc, yc, r1-div1*i, r2-div2*i,-angle*180/pi);
    eddy_division_ellipses(i+1,1,:) = elli(1,:);
    eddy_division_ellipses(i+1,2,:) = elli(2,:);
    h_rings(i+1)= plot(elli(1,:), elli(2,:),'linewidth',2);
end
ROT = [cos(angle) sin(angle); -sin(angle) cos(angle)];
for i=0:cheese-1        
    angle_cheese = 2*pi*i/cheese;
    rAngle = 1./sqrt(cos(angle_cheese)^2/r1^2+sin(angle_cheese)^2/r2^2);
    pRot = [cos(angle_cheese)*rAngle sin(angle_cheese)*rAngle]*ROT;
    pRot = [pRot(1)+xc pRot(2)+yc];
    h_cheeses(i+1)=plot([xc pRot(1)],[yc pRot(2)],'linewidth',2);
end

function plot_ellipses

global info_eddy_array;
global graphic_eddy_array;
global depth;

for i=1:length(info_eddy_array)
    if(info_eddy_array(i).r2(depth) ~= 0)
        [X Y] = calculate_ellipse(info_eddy_array(i).c_lon(depth), info_eddy_array(i).c_lat(depth), info_eddy_array(i).r1(depth), info_eddy_array(i).r2(depth), -info_eddy_array(i).angle(depth)*180/pi);
        if(graphic_eddy_array(i).ellipse ~= 0)
            delete(graphic_eddy_array(i).ellipse);
        end
        graphic_eddy_array(i).ellipse = plot(X,Y,'linewidth',2);
    end
end

function change_eddy_parameters(point,handles)
global selection;
global info_eddy_array;
global eddy_index;
global filled_vertexes;
global fill_handler;
global radial_index;
global angular_index;
global depth;

if((get(handles.togglebutton1,'Value') == 1) || (get(handles.togglebutton2,'Value') == 1) || (get(handles.togglebutton3,'Value') == 1))
    return;
end

switch selection
    case 0 
        info_eddy_array(eddy_index).modified_depths(depth) = 1;
        change_center(point);
        delete_graphic_center;
        delete_graphic_rads;
        if((~divisions_are_viewed) || (info_eddy_array(eddy_index).r2(depth) == 0))
            plot_center(eddy_index);
            plot_rads(eddy_index);
        else
            delete_graphic_divisions;
            plot_divisions;
        end   
        set(handles.text11,'String',strcat(strcat(strcat(strcat('[ ',num2str(info_eddy_array(eddy_index).c_lon(depth))),', '),num2str(info_eddy_array(eddy_index).c_lat(depth))),' ]'));
    case 1  
        change_rad_1(point);
        delete_graphic_rads;
        if((~divisions_are_viewed) || (info_eddy_array(eddy_index).r2(depth) == 0))
            plot_rads(eddy_index);  
        else
            delete_graphic_divisions;
            plot_divisions;              
        end
    case 2
        change_rad_2(point);
        delete_graphic_rads;
        if(~divisions_are_viewed)
            plot_rads(eddy_index);  
            if(info_eddy_array(eddy_index).r2(depth) ~= 0)
                set(handles.pushbutton2,'Visible','on');
                set(handles.pushbutton5,'Visible','on');
                set(handles.togglebutton2,'Visible','on');
            end
        else
            delete_graphic_divisions;
            plot_divisions;              
        end
    case 3
        if(~isempty(filled_vertexes))
            delete(fill_handler);
            filled_vertexes = [];
        end 
        dist_point = sqrt((point(1,1)-info_eddy_array(eddy_index).c_lon(depth))^2+(point(1,2)-info_eddy_array(eddy_index).c_lat(depth))^2);
        if((divisions_are_viewed) && ((dist_point < info_eddy_array(eddy_index).r1(depth)) || (dist_point < info_eddy_array(eddy_index).r2(depth))))
            fill_zone(point);
            set(handles.edit2,'Visible','on');
            set(handles.edit2,'String',info_eddy_array(eddy_index).speed(depth,radial_index,angular_index));
            set(handles.pushbutton3,'Visible','on');
        else
            filled_vertexes = [];
            set(handles.edit2,'Visible','off');
            set(handles.pushbutton3,'Visible','off');
        end
end


function change_center(point)

global info_eddy_array;
global eddy_index;
global depth;
    
info_eddy_array(eddy_index).c_lon(depth) = point(1,1);
info_eddy_array(eddy_index).c_lat(depth) = point(1,2);    
info_eddy_array(eddy_index).modified_depths(depth) = 1;
 
            
function delete_graphic_center

global graphic_eddy_array;
global eddy_index;
    
if(graphic_eddy_array(eddy_index).center ~= 0)
    delete(graphic_eddy_array(eddy_index).center);
    graphic_eddy_array(eddy_index).center = 0;
end
    
    
function delete_graphic_rads

global graphic_eddy_array;
global eddy_index;
   
if(graphic_eddy_array(eddy_index).r1 ~= 0)
    delete(graphic_eddy_array(eddy_index).r1);
    graphic_eddy_array(eddy_index).r1 = 0;
end
if(graphic_eddy_array(eddy_index).r2 ~= 0)
    delete(graphic_eddy_array(eddy_index).r2);
    graphic_eddy_array(eddy_index).r2 = 0;
end
    
    
function delete_graphic_fill(handles)

global filled_vertexes;
global fill_handler;
    
if(~isempty(filled_vertexes))
    delete(fill_handler);
    filled_vertexes = [];
    set(handles.edit2,'Visible','off');
    set(handles.pushbutton3,'Visible','off');
end
    

function delete_graphic_divisions
 
global graphic_eddy_array; 
global eddy_index;
    
if(~isempty(graphic_eddy_array(eddy_index).ellipse_rad_div))
    for i=1:length(graphic_eddy_array(eddy_index).ellipse_rad_div)
        delete(graphic_eddy_array(eddy_index).ellipse_rad_div(i));
    end
    graphic_eddy_array(eddy_index).ellipse_rad_div = [];
end
if(~isempty(graphic_eddy_array(eddy_index).ellipse_ang_div))
    for i=1:length(graphic_eddy_array(eddy_index).ellipse_ang_div)
        delete(graphic_eddy_array(eddy_index).ellipse_ang_div(i));
    end
    graphic_eddy_array(eddy_index).ellipse_ang_div = [];
end            
  

function delete_graphic_ellipses
    global graphic_eddy_array;
    
    for i=1:length(graphic_eddy_array)
        if(graphic_eddy_array(i).ellipse ~= 0)
            delete(graphic_eddy_array(i).ellipse);
            graphic_eddy_array(i).ellipse = 0;
        end
    end
    

function res = divisions_are_viewed

global graphic_eddy_array;
global eddy_index;
    
res = 1;
if(isempty(graphic_eddy_array(eddy_index).ellipse_rad_div) || isempty(graphic_eddy_array(eddy_index).ellipse_ang_div))
    res = 0;
end
    

    
function plot_center(eddy_index)

global graphic_eddy_array;
global info_eddy_array;
global depth;

graphic_eddy_array(eddy_index).center = plot(info_eddy_array(eddy_index).c_lon(depth),info_eddy_array(eddy_index).c_lat(depth),'r*');

   
    
function plot_rads(eddy_index)
    
global info_eddy_array;
global graphic_eddy_array;
global depth;

    
if(info_eddy_array(eddy_index).r1(depth) ~= 0)
    lon = info_eddy_array(eddy_index).r1(depth)*cos(info_eddy_array(eddy_index).angle(depth))+info_eddy_array(eddy_index).c_lon(depth);
    lat = info_eddy_array(eddy_index).r1(depth)*sin(info_eddy_array(eddy_index).angle(depth))+info_eddy_array(eddy_index).c_lat(depth);
    graphic_eddy_array(eddy_index).r1 = plot([lon 2*info_eddy_array(eddy_index).c_lon(depth)-lon],[lat 2*info_eddy_array(eddy_index).c_lat(depth)-lat],'r','linewidth',2);
    if(info_eddy_array(eddy_index).r2(depth) ~= 0)
        lon = info_eddy_array(eddy_index).r2(depth)*cos(pi/2+info_eddy_array(eddy_index).angle(depth))+info_eddy_array(eddy_index).c_lon(depth);
        lat = info_eddy_array(eddy_index).r2(depth)*sin(pi/2+info_eddy_array(eddy_index).angle(depth))+info_eddy_array(eddy_index).c_lat(depth);
        graphic_eddy_array(eddy_index).r2 = plot([lon 2*info_eddy_array(eddy_index).c_lon(depth)-lon],[lat 2*info_eddy_array(eddy_index).c_lat(depth)-lat],'b','linewidth',2);
    end
end

    

    
function plot_divisions

global graphic_eddy_array;
global info_eddy_array;
global eddy_index;
global depth;
    
[graphic_eddy_array(eddy_index).ellipse_rad_div,graphic_eddy_array(eddy_index).ellipse_ang_div]=ellipse(info_eddy_array(eddy_index).c_lon(depth),info_eddy_array(eddy_index).c_lat(depth),info_eddy_array(eddy_index).r1(depth),info_eddy_array(eddy_index).r2(depth),info_eddy_array(eddy_index).angle(depth),info_eddy_array(eddy_index).rad_div,info_eddy_array(eddy_index).ang_div);
    
    
function change_rad_1(point)

global info_eddy_array;
global eddy_index;
global depth;

if(info_eddy_array(eddy_index).c_lon(depth) ~= 0)
    info_eddy_array(eddy_index).modified_depths(depth) = 1;
    info_eddy_array(eddy_index).r1(depth) = sqrt((point(1,1)-info_eddy_array(eddy_index).c_lon(depth))*(point(1,1)-info_eddy_array(eddy_index).c_lon(depth))+(point(1,2)-info_eddy_array(eddy_index).c_lat(depth))*(point(1,2)-info_eddy_array(eddy_index).c_lat(depth)));
    info_eddy_array(eddy_index).angle(depth) = acos(abs(point(1,1)-info_eddy_array(eddy_index).c_lon(depth))/info_eddy_array(eddy_index).r1(depth));
else
    disp('center must be selected first');
end
    
    
function change_rad_2(point)

global info_eddy_array;
global eddy_index;
global depth;

if(info_eddy_array(eddy_index).r1(depth) ~= 0)
    info_eddy_array(eddy_index).modified_depths(depth) = 1;
    alfa = info_eddy_array(eddy_index).angle(depth) + pi/2;
    beta = get_angle(point(1,1),point(1,2));
    ganma = abs(alfa-beta);
    info_eddy_array(eddy_index).r2(depth) = sqrt((point(1,1)-info_eddy_array(eddy_index).c_lon(depth))*(point(1,1)-info_eddy_array(eddy_index).c_lon(depth))+(point(1,2)-info_eddy_array(eddy_index).c_lat(depth))*(point(1,2)-info_eddy_array(eddy_index).c_lat(depth)))*cos(ganma);
else
    disp('r1 must be selected first');
end
    
    
function fill_zone(point)

global filled_vertexes;
global fill_handler;
    
filled_vertexes = get_vertexes(point);
fill_handler = fill(filled_vertexes(1,:),filled_vertexes(2,:),'g','erasemode','xor');

    
function vertexes = get_vertexes(point)

global radial_index;
global angular_index;
    
radial_index = get_radial_index(point);
angular_index = get_angular_index(point);
main_vertexes = get_main_vertexes(radial_index,angular_index);
vertexes = get_all_vertexes(main_vertexes,radial_index,angular_index);

    
    

function index = get_radial_index(point)

global info_eddy_array;
global eddy_index;
global depth;
    
dist_point = sqrt((info_eddy_array(eddy_index).c_lon(depth) - point(1,1))*(info_eddy_array(eddy_index).c_lon(depth) - point(1,1))+(info_eddy_array(eddy_index).c_lat(depth) - point(1,2))*(info_eddy_array(eddy_index).c_lat(depth) - point(1,2)));
rad = get_radious_by_point(point);
rad_divisions = rad / info_eddy_array(eddy_index).rad_div;
rad_iterator = rad_divisions;
index = 0;
while(1)
    if((dist_point < rad_iterator) || (rad_iterator > rad))
        break;
    end
    rad_iterator = rad_iterator + rad_divisions;
    index = index + 1;
end
index = info_eddy_array(eddy_index).rad_div - index;    
    
    
function rad = get_radious_by_point(point)

global info_eddy_array;
global eddy_index;
global depth;
    
angle = get_angle(point(1,1)-info_eddy_array(eddy_index).c_lon(depth),point(1,2)-info_eddy_array(eddy_index).c_lat(depth));
rad = 1./sqrt(cos(abs(angle-info_eddy_array(eddy_index).angle(depth)))^2/info_eddy_array(eddy_index).r1(depth)^2 + sin(abs(angle-info_eddy_array(eddy_index).angle(depth)))^2/info_eddy_array(eddy_index).r2(depth)^2);
    

function index = get_angular_index(point)

global info_eddy_array;
global eddy_index;
global depth;
    
angle = get_angle(point(1,1)-info_eddy_array(eddy_index).c_lon(depth),point(1,2)-info_eddy_array(eddy_index).c_lat(depth));    
angle = simplify_angle(angle - info_eddy_array(eddy_index).angle(depth));
angular_section = 2*pi / info_eddy_array(eddy_index).ang_div;
index = floor(angle / angular_section) + 1;
    
    
function main_vertexes = get_main_vertexes(radial_index,angular_index)

global info_eddy_array;
global eddy_index;
global depth;
    
angle_1 = info_eddy_array(eddy_index).angle(depth) + (angular_index-1)*2*pi/info_eddy_array(eddy_index).ang_div;
angle_2 = info_eddy_array(eddy_index).angle(depth) + angular_index*2*pi/info_eddy_array(eddy_index).ang_div;
    
r1_1 = get_radious(angle_1-info_eddy_array(eddy_index).angle(depth),radial_index);
r2_1 = get_radious(angle_1-info_eddy_array(eddy_index).angle(depth),radial_index+1);
    
r1_2 = get_radious(angle_2-info_eddy_array(eddy_index).angle(depth),radial_index);
r2_2 = get_radious(angle_2-info_eddy_array(eddy_index).angle(depth),radial_index+1);
    
main_vertexes(1,1) = get_lon_hypo(r1_1,angle_1);
main_vertexes(2,1) = get_lat_hypo(r1_1,angle_1);
main_vertexes(1,2) = get_lon_hypo(r2_1,angle_1);
main_vertexes(2,2) = get_lat_hypo(r2_1,angle_1);
main_vertexes(1,3) = get_lon_hypo(r1_2,angle_2);
main_vertexes(2,3) = get_lat_hypo(r1_2,angle_2);
if((r2_1 == 0) && (r2_2 == 0))
    return;
end
main_vertexes(1,4) = get_lon_hypo(r2_2,angle_2);
main_vertexes(2,4) = get_lat_hypo(r2_2,angle_2);
    

function rad = get_radious(angle,index)

global info_eddy_array;
global eddy_index;
global depth;
    
r1 = info_eddy_array(eddy_index).r1(depth) - (index-1)*info_eddy_array(eddy_index).r1(depth)/info_eddy_array(eddy_index).rad_div;
r2 = info_eddy_array(eddy_index).r2(depth) - (index-1)*info_eddy_array(eddy_index).r2(depth)/info_eddy_array(eddy_index).rad_div;
    
if((r1 == 0) || (r2 == 0))
    rad = 0;
else
    rad = 1./sqrt(cos(angle)^2/r1^2 + sin(angle)^2/r2^2);
end
    

function lon = get_lon_hypo(rad,angle)

global info_eddy_array;
global eddy_index;
global depth;
   
angle = simplify_angle(angle);
   
if((angle < pi/2) || (angle > 3*pi/2))
    lon = sqrt(rad^2 - (sin(angle)*rad)^2) + info_eddy_array(eddy_index).c_lon(depth);
else
    lon = -sqrt(rad^2 - (sin(angle)*rad)^2) + info_eddy_array(eddy_index).c_lon(depth);
end

 

function lat = get_lat_hypo(rad,angle)

global info_eddy_array;
global eddy_index;
global depth;
    
angle = simplify_angle(angle);
    
if(angle < pi)
    lat = sqrt(rad^2 - (cos(angle)*rad)^2) + info_eddy_array(eddy_index).c_lat(depth);
else
    lat = -sqrt(rad^2 - (cos(angle)*rad)^2) + info_eddy_array(eddy_index).c_lat(depth);
end
 
    
function vertexes = get_all_vertexes(main_vertexes,radial_index,angular_index)

if(length(main_vertexes(1,:)) == 4)
    middle_points_1 = get_middle_points(main_vertexes(:,1),main_vertexes(:,3),radial_index,angular_index);
    middle_points_2 = get_middle_points(main_vertexes(:,2),main_vertexes(:,4),radial_index+1,angular_index);
    
    vertexes = [main_vertexes(:,1),middle_points_1,main_vertexes(:,3),main_vertexes(:,4),flipdim(middle_points_2,2),main_vertexes(:,2)];
else
    middle_points_1 = get_middle_points(main_vertexes(:,1),main_vertexes(:,3),radial_index,angular_index);
    vertexes = [main_vertexes(:,1),middle_points_1,main_vertexes(:,3),main_vertexes(:,2)];
end
    

function middle_points = get_middle_points(p_1,p_2,radial_index,angular_index)

global eddy_division_ellipses;
global info_eddy_array;
global eddy_index;
global depth;
    
angular_section = 2*pi / info_eddy_array(eddy_index).ang_div;
    
angle_1 = simplify_angle(get_angle(p_1(1)-info_eddy_array(eddy_index).c_lon(depth),p_1(2)-info_eddy_array(eddy_index).c_lat(depth))-info_eddy_array(eddy_index).angle(depth));
angle_2 = simplify_angle(get_angle(p_2(1)-info_eddy_array(eddy_index).c_lon(depth),p_2(2)-info_eddy_array(eddy_index).c_lat(depth))-info_eddy_array(eddy_index).angle(depth));
    
middle_points = [];
for i=1:length(eddy_division_ellipses(radial_index,1,:))
    angle_point = get_angle(eddy_division_ellipses(radial_index,1,i)-info_eddy_array(eddy_index).c_lon(depth),eddy_division_ellipses(radial_index,2,i)-info_eddy_array(eddy_index).c_lat(depth));
    angle_point = simplify_angle(angle_point - info_eddy_array(eddy_index).angle(depth));
    if((angular_index == floor(angle_point / angular_section) + 1) && (angle_1 ~= angle_point) && (angle_2 ~= angle_point))
        middle_points = [middle_points,eddy_division_ellipses(radial_index,:,i)'];
    end
end


% --- Executes on button press in togglebutton1.
function togglebutton1_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton1
% --- Executes on button press in togglebutton1.
global time;
global depth;
global eddy_map_array;
global info_eddy_array;
global axes_eddy_1;
global axes_eddy_2;
global automatic_map_array;
global error;
global longitudes;
global latitudes;
global U;
global V;

global rotate_max_area;
global max_angle_diff;

if(get(handles.togglebutton2,'Value') == 0)
    ax = axis;
end
hold off;
if(get(hObject,'Value') == 1) 
    set(handles.togglebutton3,'Value',0);
    if(axes_eddy_1 ~= 0)
        axes_eddy_1 = 0;
        axes_eddy_2 = 0;
    end
    eddy_map_array(time).eddies = info_eddy_array;
    set(handles.checkbox2,'Value',0);
    set(handles.uipanel1,'Visible','off');
    set(handles.pushbutton3,'Visible','off');
    set(handles.edit2,'Visible','off');
    
    area = str2num(get(handles.edit3,'String'));
    angle = str2num(get(handles.edit4,'String'));
        
    if(isempty(automatic_map_array(depth,time).eddies) || (area~=rotate_max_area) || (angle~=max_angle_diff))
        rotate_max_area = area;
        max_angle_diff = angle;
        [automatic_map_array(depth,time).eddies,error(depth,time)] = eddy_shape_ellipse_detection(longitudes,latitudes,U,V,time,depth,rotate_max_area,max_angle_diff*pi/180);
    else
        draw_map(longitudes,latitudes,U,V,depth,time);
        axis equal;
        hold on;
        for i=1:length(automatic_map_array(depth,time).eddies)
            [ellipse_points(1,:),ellipse_points(2,:)] = calculate_ellipse(automatic_map_array(depth,time).eddies(i).c_lon,automatic_map_array(depth,time).eddies(i).c_lat,automatic_map_array(depth,time).eddies(i).r1,automatic_map_array(depth,time).eddies(i).r2,-180/pi*automatic_map_array(depth,time).eddies(i).angle);
            if(automatic_map_array(depth,time).eddies(i).cyclonic)
                plot(ellipse_points(1,:),ellipse_points(2,:),'b','linewidth',2);
            else
                plot(ellipse_points(1,:),ellipse_points(2,:),'r','linewidth',2);
            end
        end
    end
    if(get(handles.togglebutton2,'Value') == 0)
        axis(ax);
    else
        set(handles.togglebutton2,'Value',0);
    end
else
    info_eddy_array = eddy_map_array(time).eddies;
    set_graphic_handlers;
    draw_map(longitudes,latitudes,U,V,depth,time);
    axis(ax);
    hold on;
    plot_eddies(handles);
    set(handles.uipanel1,'Visible','on');
end


% --- Executes on button press in togglebutton2.
function togglebutton2_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton2
global time;
global depth;
global eddy_map_array;
global info_eddy_array;
global axes_eddy_1;
global axes_eddy_2;
global automatic_map_array;
global error;
global longitudes;
global latitudes;
global U;
global V;

global rotate_max_area;
global max_angle_diff;

hold off;
for i=1:length(eddy_map_array)
    if(eddy_map_array(i).t == time)
        index_time = i;
        break;
    end
end
if(get(hObject,'Value') == 1)
    if(info_eddy_array(1).r2(depth) > 0)
        if(axes_eddy_1 ~= 0)
            axes_eddy_1 = 0;
            axes_eddy_2 = 0;
        end
        eddy_map_array(index_time).eddies = info_eddy_array;
        set(handles.togglebutton1,'Value',0);
        set(handles.togglebutton3,'Value',0);
        set(handles.checkbox2,'Value',0);
        set(handles.uipanel1,'Visible','off');
        set(handles.pushbutton3,'Visible','off');
        set(handles.edit2,'Visible','off');
    
        area = str2num(get(handles.edit3,'String'));
        angle = str2num(get(handles.edit4,'String'));
        
        if(isempty(automatic_map_array(depth,time).eddies) || (area~=rotate_max_area) || (angle~=max_angle_diff))
            rotate_max_area = area;
            max_angle_diff = angle;
            [automatic_map_array(depth,time).eddies,error(depth,time)] = eddy_shape_ellipse_detection(longitudes,latitudes,U,V,time,depth,rotate_max_area,max_angle_diff*pi/180);
            hold off;
        end
        [match,diff_radio_props,diff_angle,found_ratio,excess_ratio,perceptual_error,size_error,global_error] = compare_eddy_ellipse(longitudes,latitudes,info_eddy_array,automatic_map_array(depth,time).eddies,depth);
        set(handles.text6,'String',strcat(strcat('Detection Matching = ',num2str(match)),'%'));
        set(handles.text7,'String',strcat(strcat('Found Ratio = ',num2str(found_ratio)),'%'));
        set(handles.text8,'String',strcat(strcat('Excess Ratio = ',num2str(excess_ratio)),'%'));
        set(handles.text9,'String',strcat('Radio Proportions Error = ',num2str(diff_radio_props)));
        set(handles.text10,'String',strcat(strcat('Raw Angle Error = ',num2str(diff_angle)),'%'));
        set(handles.text12,'String',strcat(strcat('Perceptual Angle Error = ',num2str(perceptual_error)),'%'));
        set(handles.text13,'String',strcat('Size Error = ',num2str(size_error)));
        set(handles.text14,'String',strcat('Global Error = ',num2str(global_error)));
        set(handles.text15,'String',strcat(strcat('Adaptability Error = ',num2str(error(depth,time)*100/pi)),'%'));
    else
        hold on;
        set(handles.togglebutton2,'Value',0);
    end
else
    info_eddy_array = eddy_map_array(index_time).eddies;
    set_graphic_handlers;
    draw_map(longitudes,latitudes,U,V,depth,time);
    axis equal
    hold on;
    plot_eddies(handles);
    set(handles.uipanel1,'Visible','on');
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global info_eddy_array;
global eddy_index;
global depth;
global U;

if(~isempty(info_eddy_array(eddy_index).speed))
    deb=info_eddy_array(eddy_index).speed(depth,:,:);
    [info_eddy_array(eddy_index)] = estimate_3D_eddy(info_eddy_array(eddy_index),length(U(1,1,:,1)),info_eddy_array(eddy_index).c_lon(depth),info_eddy_array(eddy_index).c_lat(depth),depth,info_eddy_array(eddy_index).r1(depth),info_eddy_array(eddy_index).r2(depth),info_eddy_array(eddy_index).angle(depth),squeeze(info_eddy_array(eddy_index).speed(depth,:,:)));
end

% --- Executes on button press in togglebutton3.
function togglebutton3_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton3
global time;
global depth;
global eddy_map_array;
global info_eddy_array;
global axes_eddy_1;
global axes_eddy_2;
global longitudes;
global latitudes;
global U;
global V;

compare = get(handles.togglebutton2,'Value');
if(~compare)
    ax = axis;
end
hold off;
if(get(hObject,'Value') == 1)
    if(axes_eddy_1 ~= 0)
        axes_eddy_1 = 0;
        axes_eddy_2 = 0;
    end
    eddy_map_array(time).eddies = info_eddy_array;
    set(handles.togglebutton1,'Value',0);
    set(handles.togglebutton2,'Value',0);
    set(handles.checkbox2,'Value',0);
    set(handles.uipanel1,'Visible','off');
    set(handles.pushbutton3,'Visible','off');
    set(handles.edit2,'Visible','off');
    rotate_max_area = str2num(get(handles.edit3,'String'));
    max_angle_diff = str2num(get(handles.edit4,'String'))*pi/180;
    eddy_track(longitudes,latitudes,U,V,time,length(U(1,1,1,:)),depth,rotate_max_area,max_angle_diff);
else
    info_eddy_array = eddy_map_array(time).eddies;
    draw_map(longitudes,latitudes,U,V,depth,time);
    axis equal;
    hold on;
    set_graphic_handlers;
    plot_eddies(handles);
    set(handles.uipanel1,'Visible','on');
end
if(~compare)
    axis(ax);
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double


% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double


% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
