function ellipse_points = get_ellipse_points(lon,lat,axis_1,axis_2,angle,steps_are_important)
    dist_axis_1 = sqrt((axis_1(1) - lon) * (axis_1(1) - lon) + (axis_1(2) - lat) * (axis_1(2) - lat));
    dist_axis_2 = sqrt((axis_2(1) - lon) * (axis_2(1) - lon) + (axis_2(2) - lat) * (axis_2(2) - lat));
    if(steps_are_important)
        steps = 4*(round(dist_axis_1)+round(dist_axis_2))-4;
        if(steps < 8)
            steps = 8;
        end
    else
        steps = 36;
    end
    ellipse_points = zeros(2,steps);
    [ellipse_points(1,:),ellipse_points(2,:)] = calculate_ellipse(lon,lat,dist_axis_1,dist_axis_2,-180/pi*angle,steps);
end