function sorted_contour = sort_eddy_contour(contour)
    sorted_contour = zeros(2,length(contour(1,:)));
    actual_point = contour(:,1);
    contour(:,1) = [];
    sorted_contour(:,1) = actual_point;
    i = 1;
    while(~isempty(contour))
        [actual_point,index] = get_next_point(actual_point,contour);
        contour(:,index) = [];
        i = i + 1;
        sorted_contour(:,i) = actual_point;
    end
end

function [actual_point,index] = get_next_point(actual_point,contour)
    distances = get_distances(actual_point,contour);
    [~,index] = min(distances);
    actual_point = contour(:,index);
end

function distances = get_distances(actual_point,contour)
    distances = zeros(1,length(contour(1,:)));
    for i=1:length(contour(1,:))
        distances(i) = norm(contour(:,i) - actual_point);
    end
end